## dracut 059

=== Makefile ===
-include dracut-version.sh

DRACUT_MAIN_VERSION := $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --abbrev=0 --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_MAIN_VERSION),)
DRACUT_MAIN_VERSION = $(DRACUT_VERSION)
endif
DRACUT_FULL_VERSION := $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_FULL_VERSION),)
DRACUT_FULL_VERSION = $(DRACUT_VERSION)
endif

HAVE_SHELLCHECK ?= $(shell which shellcheck >/dev/null 2>&1 && echo yes)
HAVE_SHFMT ?= $(shell which shfmt >/dev/null  2>&1 && echo yes)
HAVE_RPMBUILD ?= $(shell which rpmbuild >/dev/null  2>&1 && echo yes)

-include Makefile.inc

KVERSION ?= $(shell uname -r)

prefix ?= /usr
libdir ?= ${prefix}/lib
datadir ?= ${prefix}/share
pkglibdir ?= ${libdir}/dracut
sysconfdir ?= ${prefix}/etc
bindir ?= ${prefix}/bin
mandir ?= ${prefix}/share/man
CFLAGS ?= -O2 -g -Wall -std=gnu99 -D_FILE_OFFSET_BITS=64 -Wformat -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2
bashcompletiondir ?= ${datadir}/bash-completion/completions
pkgconfigdatadir ?= $(datadir)/pkgconfig

man1pages = man/lsinitrd.1

man5pages = man/dracut.conf.5

man7pages = man/dracut.cmdline.7 \
            man/dracut.bootup.7 \
            man/dracut.modules.7

man8pages = man/dracut.8 \
            man/dracut-catimages.8 \
            modules.d/98dracut-systemd/dracut-cmdline.service.8 \
            modules.d/98dracut-systemd/dracut-initqueue.service.8 \
            modules.d/98dracut-systemd/dracut-mount.service.8 \
            modules.d/98dracut-systemd/dracut-shutdown.service.8 \
            modules.d/98dracut-systemd/dracut-pre-mount.service.8 \
            modules.d/98dracut-systemd/dracut-pre-pivot.service.8 \
            modules.d/98dracut-systemd/dracut-pre-trigger.service.8 \
            modules.d/98dracut-systemd/dracut-pre-udev.service.8

manpages = $(man1pages) $(man5pages) $(man7pages) $(man8pages)

.PHONY: install clean archive rpm srpm testimage test all check AUTHORS CONTRIBUTORS doc dracut-version.sh

all: dracut-version.sh dracut.pc dracut-install src/skipcpio/skipcpio dracut-util

%.o : %.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(KMOD_CFLAGS) $< -o $@

DRACUT_INSTALL_OBJECTS = \
        src/install/dracut-install.o \
        src/install/hashmap.o\
        src/install/log.o \
        src/install/strv.o \
        src/install/util.o

# deps generated with gcc -MM
src/install/dracut-install.o: src/install/dracut-install.c src/install/log.h src/install/macro.h \
	src/install/hashmap.h src/install/util.h
src/install/hashmap.o: src/install/hashmap.c src/install/util.h src/install/macro.h src/install/log.h \
	src/install/hashmap.h
src/install/log.o: src/install/log.c src/install/log.h src/install/macro.h src/install/util.h
src/install/util.o: src/install/util.c src/install/util.h src/install/macro.h src/install/log.h
src/install/strv.o: src/install/strv.c src/install/strv.h src/install/util.h src/install/macro.h src/install/log.h

src/install/dracut-install: $(DRACUT_INSTALL_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(DRACUT_INSTALL_OBJECTS) $(LDLIBS) $(FTS_LIBS) $(KMOD_LIBS)

logtee: src/logtee/logtee.c
	$(CC) $(LDFLAGS) -o $@ $<

dracut-install: src/install/dracut-install
	ln -fs $< $@

SKIPCPIO_OBJECTS = src/skipcpio/skipcpio.o
skipcpio/skipcpio.o: src/skipcpio/skipcpio.c
skipcpio/skipcpio: $(SKIPCPIO_OBJECTS)

UTIL_OBJECTS = src/util/util.o
util/util.o: src/util/util.c
util/util: $(UTIL_OBJECTS)

dracut-util: src/util/util
	cp -a $< $@

.PHONY: indent-c
indent-c:
	astyle -n --quiet --options=.astylerc $(wildcard *.[ch] */*.[ch] src/*/*.[ch])

.PHONY: indent
indent: indent-c
ifeq ($(HAVE_SHFMT),yes)
	shfmt -w -s .
endif

src/dracut-cpio/target/release/dracut-cpio: src/dracut-cpio/src/main.rs
	cargo --offline build --release --manifest-path src/dracut-cpio/Cargo.toml

dracut-cpio: src/dracut-cpio/target/release/dracut-cpio
	ln -fs $< $@

ifeq ($(enable_dracut_cpio),yes)
all: dracut-cpio
endif

doc: $(manpages) dracut.html

ifneq ($(enable_documentation),no)
all: doc
endif

%: %.xml
	@rm -f -- "$@"
	xsltproc -o "$@" -nonet http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl $<

%.xml: %.asc
	@rm -f -- "$@"
	asciidoc -a "version=$(DRACUT_FULL_VERSION)" -d manpage -b docbook -o "$@" $<

dracut.8: man/dracut.8.asc \
	man/dracut.usage.asc

dracut.html: man/dracut.asc $(manpages) docs/dracut.css man/dracut.usage.asc
	@rm -f -- dracut.xml
	asciidoc -a "mainversion=$(DRACUT_MAIN_VERSION)" \
		-a "version=$(DRACUT_FULL_VERSION)" \
		-a numbered \
		-d book -b docbook -o dracut.xml man/dracut.asc
	@rm -f -- dracut.html
	xsltproc -o dracut.html --xinclude -nonet \
		--stringparam custom.css.source docs/dracut.css \
		--stringparam generate.css.header 1 \
		http://docbook.sourceforge.net/release/xsl/current/xhtml/docbook.xsl dracut.xml
	@rm -f -- dracut.xml

dracut.pc: Makefile.inc Makefile
	@echo "Name: dracut" > dracut.pc
	@echo "Description: dracut" >> dracut.pc
	@echo "Version: $(DRACUT_FULL_VERSION)" >> dracut.pc
	@echo "dracutdir=$(pkglibdir)" >> dracut.pc
	@echo "dracutmodulesdir=$(pkglibdir)/modules.d" >> dracut.pc
	@echo "dracutconfdir=$(pkglibdir)/dracut.conf.d" >> dracut.pc

install: all
	mkdir -p $(DESTDIR)$(pkglibdir)
	mkdir -p $(DESTDIR)$(bindir)
	mkdir -p $(DESTDIR)$(sysconfdir)
	mkdir -p $(DESTDIR)$(pkglibdir)/modules.d
	mkdir -p $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man5 $(DESTDIR)$(mandir)/man7 $(DESTDIR)$(mandir)/man8
	install -m 0755 dracut.sh $(DESTDIR)$(bindir)/dracut
	install -m 0755 dracut-catimages.sh $(DESTDIR)$(bindir)/dracut-catimages
	install -m 0755 lsinitrd.sh $(DESTDIR)$(bindir)/lsinitrd
	install -m 0644 dracut.conf $(DESTDIR)$(sysconfdir)/dracut.conf
	mkdir -p $(DESTDIR)$(sysconfdir)/dracut.conf.d
	mkdir -p $(DESTDIR)$(pkglibdir)/dracut.conf.d
	install -m 0755 dracut-init.sh $(DESTDIR)$(pkglibdir)/dracut-init.sh
	install -m 0755 dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions.sh
	install -m 0755 dracut-version.sh $(DESTDIR)$(pkglibdir)/dracut-version.sh
	ln -fs dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions
	install -m 0755 dracut-logger.sh $(DESTDIR)$(pkglibdir)/dracut-logger.sh
	install -m 0755 dracut-initramfs-restore.sh $(DESTDIR)$(pkglibdir)/dracut-initramfs-restore
	cp -arx modules.d $(DESTDIR)$(pkglibdir)
ifneq ($(enable_documentation),no)
	for i in $(man1pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man1/$${i##*/}; done
	for i in $(man5pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man5/$${i##*/}; done
	for i in $(man7pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man7/$${i##*/}; done
	for i in $(man8pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man8/$${i##*/}; done
	ln -fs dracut.cmdline.7 $(DESTDIR)$(mandir)/man7/dracut.kernel.7
endif
	if [ -n "$(systemdsystemunitdir)" ]; then \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir); \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/98dracut-systemd/dracut-shutdown-onfailure.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown-onfailure.service; \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/98dracut-systemd/dracut-shutdown.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants; \
		ln -s ../dracut-shutdown.service \
		$(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants; \
		for i in \
		    dracut-cmdline.service \
		    dracut-initqueue.service \
		    dracut-mount.service \
		    dracut-pre-mount.service \
		    dracut-pre-pivot.service \
		    dracut-pre-trigger.service \
		    dracut-pre-udev.service \
		    ; do \
			ln -srf $(DESTDIR)$(pkglibdir)/modules.d/98dracut-systemd/$$i $(DESTDIR)$(systemdsystemunitdir); \
			ln -s ../$$i \
			$(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants/$$i; \
		done \
	fi
	if [ -f src/install/dracut-install ]; then \
		install -m 0755 src/install/dracut-install $(DESTDIR)$(pkglibdir)/dracut-install; \
	fi
	if [ -f src/skipcpio/skipcpio ]; then \
		install -m 0755 src/skipcpio/skipcpio $(DESTDIR)$(pkglibdir)/skipcpio; \
	fi
	if [ -f dracut-util ]; then \
		install -m 0755 dracut-util $(DESTDIR)$(pkglibdir)/dracut-util; \
	fi
ifeq ($(enable_dracut_cpio),yes)
	install -m 0755 dracut-cpio $(DESTDIR)$(pkglibdir)/dracut-cpio
endif
	mkdir -p $(DESTDIR)${prefix}/lib/kernel/install.d
	install -m 0755 install.d/50-dracut.install $(DESTDIR)${prefix}/lib/kernel/install.d/50-dracut.install
	install -m 0755 install.d/51-dracut-rescue.install $(DESTDIR)${prefix}/lib/kernel/install.d/51-dracut-rescue.install
	mkdir -p $(DESTDIR)${bashcompletiondir}
	install -m 0644 shell-completion/bash/dracut $(DESTDIR)${bashcompletiondir}/dracut
	install -m 0644 shell-completion/bash/lsinitrd $(DESTDIR)${bashcompletiondir}/lsinitrd
	mkdir -p $(DESTDIR)${pkgconfigdatadir}
	install -m 0644 dracut.pc $(DESTDIR)${pkgconfigdatadir}/dracut.pc

dracut-version.sh:
	@rm -f dracut-version.sh
	@printf "#!/bin/sh\n# shellcheck disable=SC2034\nDRACUT_VERSION=%s\n" "$(DRACUT_FULL_VERSION)" > dracut-version.sh

clean:
	$(RM) *~
	$(RM) */*~
	$(RM) */*/*~
	$(RM) $(manpages:%=%.xml) dracut.xml
	$(RM) test-*.img
	$(RM) dracut-*.rpm dracut-*.tar.bz2 dracut-*.tar.xz
	$(RM) dracut-version.sh
	$(RM) dracut-install src/install/dracut-install $(DRACUT_INSTALL_OBJECTS)
	$(RM) skipcpio/skipcpio $(SKIPCPIO_OBJECTS)
	$(RM) dracut-util util/util $(UTIL_OBJECTS)
	$(RM) $(manpages) dracut.html
	$(RM) dracut.pc
	$(RM) dracut-cpio src/dracut-cpio/target/release/dracut-cpio*
	$(MAKE) -C test clean

dist: dracut-$(DRACUT_MAIN_VERSION).tar.xz

dracut-$(DRACUT_MAIN_VERSION).tar.xz: doc syncheck
	@echo "DRACUT_VERSION=$(DRACUT_MAIN_VERSION)" > dracut-version.sh
	git archive --format=tar $(DRACUT_MAIN_VERSION) --prefix=dracut-$(DRACUT_MAIN_VERSION)/ > dracut-$(DRACUT_MAIN_VERSION).tar
	mkdir -p dracut-$(DRACUT_MAIN_VERSION)
	for i in $(manpages) dracut.html dracut-version.sh; do [ "$${i%/*}" != "$$i" ] && mkdir -p "dracut-$(DRACUT_MAIN_VERSION)/$${i%/*}"; cp "$$i" "dracut-$(DRACUT_MAIN_VERSION)/$$i"; done
	tar --owner=root --group=root -rf dracut-$(DRACUT_MAIN_VERSION).tar $$(find dracut-$(DRACUT_MAIN_VERSION) -type f)
	rm -fr -- dracut-$(DRACUT_MAIN_VERSION).tar.xz dracut-$(DRACUT_MAIN_VERSION)
	xz -9 dracut-$(DRACUT_MAIN_VERSION).tar
	rm -f -- dracut-$(DRACUT_MAIN_VERSION).tar

ifeq ($(HAVE_RPMBUILD),yes)
rpm: dracut-$(DRACUT_MAIN_VERSION).tar.xz syncheck
	rpmbuild=$$(mktemp -d -p /var/tmp rpmbuild-dracut.XXXXXX); src=$$(pwd); \
	cp dracut-$(DRACUT_MAIN_VERSION).tar.xz "$$rpmbuild"; \
	LC_MESSAGES=C $$src/tools/git2spec.pl $(DRACUT_MAIN_VERSION) "$$rpmbuild" < pkgbuild/dracut.spec > $$rpmbuild/dracut.spec; \
	(cd "$$rpmbuild"; \
	wget https://www.gnu.org/licenses/lgpl-2.1.txt; \
	rpmbuild --define "_topdir $$PWD" --define "_sourcedir $$PWD" \
	        --define "_specdir $$PWD" --define "_srcrpmdir $$PWD" \
		--define "_rpmdir $$PWD" -ba dracut.spec; ) && \
	( mv "$$rpmbuild"/{,$$(uname -m)/}*.rpm $(DESTDIR).; rm -fr -- "$$rpmbuild"; ls $(DESTDIR)*.rpm )

srpm: dracut-$(DRACUT_MAIN_VERSION).tar.xz syncheck
	rpmbuild=$$(mktemp -d -t rpmbuild-dracut.XXXXXX); src=$$(pwd); \
	cp dracut-$(DRACUT_MAIN_VERSION).tar.xz "$$rpmbuild"; \
	LC_MESSAGES=C $$src/tools/git2spec.pl $(DRACUT_MAIN_VERSION) "$$rpmbuild" < pkgbuild/dracut.spec > $$rpmbuild/dracut.spec; \
	(cd "$$rpmbuild"; \
	[ -f $$src/lgpl-2.1.txt ] && cp $$src/lgpl-2.1.txt . || wget https://www.gnu.org/licenses/lgpl-2.1.txt; \
	rpmbuild --define "_topdir $$PWD" --define "_sourcedir $$PWD" \
	        --define "_specdir $$PWD" --define "_srcrpmdir $$PWD" \
		--define "_rpmdir $$PWD" -bs dracut.spec; ) && \
	( mv "$$rpmbuild"/*.src.rpm $(DESTDIR).; rm -fr -- "$$rpmbuild"; ls $(DESTDIR)*.rpm )
else
.PHONY: rpm srpm
rpm: syncheck
srpm: syncheck
endif

syncheck:
	@ret=0;for i in dracut-initramfs-restore.sh modules.d/*/*.sh; do \
                [ "$${i##*/}" = "module-setup.sh" ] && continue; \
                read line < "$$i"; [ "$${line#*bash*}" != "$$line" ] && continue; \

=== test/Makefile ===
.PHONY: all check clean $(wildcard TEST-??-*)

$(wildcard TEST-??-*):
	@[ "$(shell id -u)" = 0 ] || { echo "'check' must be run as root! Please use 'sudo'."; exit 1; }
	@{ \
		[ -d $@ ] || exit 0; \
		[ -f $@/Makefile ] || exit 0; \
		if [ -n "$$TESTS" ]; then t=$${$@##TEST-}; t=$${t%%-*}; [ "$${TESTS#*$$t*}" != "$$TESTS" ] || exit 0; fi; \
		if [ -n "$$SKIP" ]; then t=$${$@##TEST-}; t=$${t%%-*}; [ "$${SKIP#*$$t*}" != "$$SKIP" ] && exit 0; fi; \
		$(MAKE) -C $@ all ; \
	}

check: $(wildcard TEST-??-*)

clean:
	@for i in TEST-[0-9]*; do \
		[ -d $$i ] || continue ; \
		[ -f $$i/Makefile ] || continue ; \
		$(MAKE) -C $$i clean ; \
	done

all:

=== debian/changelog ===
dracut (059-4ubuntu2) mantic; urgency=medium

  * Split dracut-install into separate package for initramfs-tools
    (LP: #2031185)
  * Update out-of-tree patches to final version merged upstream
  * Cherry-pick upstream fixes:
    - fix(dracut-systemd): rootfs-generator issues
    - test: increase test VM memory from 512M to 1024M to avoid OOM killer
  * Address lintian complains:
    - Remove empty directories in /usr/lib/dracut/modules.d
    - Add ${misc:Depends} to all binary package dependencies
    - Override lintian complaint executable-in-usr-lib (reported upstream)
    - Override false positive about missing init.d scripts
  * Install files from debian/tmp to make dh_missing happy
  * Install dracut.kernel.7 man page (link to dracut.cmdline.7)
  * Restrict autopkgtest to amd64 (other architectures need upstrem work)
  * autopkgtest: run more upstream test cases

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 22 Aug 2023 16:34:06 +0200

dracut (059-4ubuntu1) mantic; urgency=medium

  * fix(test): running tests no longer requires to be root
  * test: Make dracut and modules.d directory configurable
  * Add upstream autopkgtest to run four test cases (LP: #2031417)
  * Add modules 80test, 80test-makeroot, and 80test-root to dracut-core

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 16 Aug 2023 02:02:13 +0200

dracut (059-4) unstable; urgency=low

  * Fix file name in patch initrd-not-initramfs.patch
    Closes: #1029413, #1030191
    Thanks to nabijaczleweli for for the patch

 -- Thomas Lange <lange@debian.org>  Thu, 09 Mar 2023 19:13:42 +0100

dracut (059-3) unstable; urgency=low

  * control: add breaks + replaces, Closes: #1028303

 -- Thomas Lange <lange@debian.org>  Mon, 09 Jan 2023 20:56:29 +0100

dracut (059-2) unstable; urgency=low

  * add patches from Laszlo Gombos
    dracut-live only depends on dracut-core not on dracut-network
    overlayfs dracut module belongs to dracut-core and not to dracut-live
    wicked dracut module is not supported by debian
    remove multipath patch, no longer needed

 -- Thomas Lange <lange@debian.org>  Sat, 07 Jan 2023 11:43:33 +0100

dracut (059-1) unstable; urgency=low

  * new upstream version
  * control: new homepage, new standards version
  * remove 10-debian.conf, build generic initrd by default
  * rules: run script explicitly as shell, Closes: #1025378
  * nm-path: fix more paths, Closes: #1016741
  * patches/udevsettle: fix broken network in kvm in some cases
  * remove dev-shm patch which is not needed, Closes: #1025996
  * remove systemd-users patch, Closes: #1025951

 -- Thomas Lange <lange@debian.org>  Sun, 25 Dec 2022 17:09:02 +0100

dracut (057+157-4) unstable; urgency=low

  * add missing module 90overlayfs

 -- Thomas Lange <lange@debian.org>  Fri, 02 Dec 2022 16:19:16 +0100

=== debian/control ===
Source: dracut
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Lange <lange@debian.org>
Build-Depends: debhelper-compat (= 12), debhelper, asciidoc-base, xsltproc, docbook-xsl, docbook-xml, quilt, libkmod-dev, pkg-config
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/dracut
Vcs-Git: https://salsa.debian.org/debian/dracut.git
Homepage: https://github.com/dracutdevs/dracut/wiki/

Package: dracut
Architecture: all
Multi-Arch: foreign
Suggests: dracut-network
Depends: dracut-core (>= ${binary:Version}), dracut-core (<< ${binary:Version}+b+~), ${misc:Depends}
Provides: linux-initramfs-tool
Conflicts: initramfs-tools, live-tools
Description: Initramfs generator using udev
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: dracut-core
Architecture: any
Multi-Arch: foreign
Recommends: cryptsetup, dmsetup, dmraid, lvm2, mdadm, console-setup, binutils, systemd, pigz, pkg-config
Depends: cpio, dracut-install, kmod, udev, kpartx, libkmod2, e2fsprogs, ${shlibs:Depends}, ${misc:Depends}
Breaks: dracut-network (<< 057+157-2), dracut-live (<< 059-2)
Replaces: dracut-network (<< 057+157-2), dracut-live (<< 059-2)
Description: dracut is an event driven initramfs infrastructure (core tools)
 Unlike existing initramfs's, this is an attempt at having as little as
 possible hard-coded into the initramfs as possible.  The initramfs has
 (basically) one purpose in life -- getting the rootfs mounted so that
 we can transition to the real rootfs.  This is all driven off of
 device availability.  Therefore, instead of scripts hard-coded to do
 various things, we depend on udev to create device nodes for us and
 then when we have the rootfs's device node, we mount and carry on.
 Having the root on MD, LVM2, LUKS is supported as well as NFS, iSCSI,
 NBD and FCOE with dracut-network.

Package: dracut-install
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: dracut-core (<< 059-4ubuntu2~)
Replaces: dracut-core (<< 059-4ubuntu2~)
Description: dracut is an event driven initramfs infrastructure (dracut-install)
 This package just contains the dracut-install command to be used by
 initramfs generating tools.

Package: dracut-network
Architecture: all
Recommends: nfs-common, open-iscsi, nbd-client, curl
Depends: dracut-core, iputils-arping, isc-dhcp-client, ${misc:Depends}
Description: dracut is an event driven initramfs infrastructure (network modules)
 Package to build a dracut initramfs with network support. This
 includes dracut modules for NFS, CIFS, iSCSI, HTTP, NBD, FCP and FCOE.

Package: dracut-squash
Architecture: all
Depends: dracut-core, squashfs-tools, ${misc:Depends}
Breaks: dracut-core (<< 050-1)
Replaces: dracut-core (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (squashfs modules)
 Package to build an initramfs with most files in a squashfs image.
 .
 This package provides a dracut module to build an initramfs, but
 store most files in a squashfs image, result in a smaller initramfs
 size and reduce runtime memory usage.

Package: dracut-live
Architecture: all
Recommends: dracut-network
Depends: dracut-core, dmsetup, ${misc:Depends}
Breaks: dracut-network (<< 050-1), dracut-core (<< 050-1)
Replaces: dracut-network (<< 050-1), dracut-core (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (live image modules)
 Package to build a dracut initramfs with live image capabilities.
 .
 This package requires everything which is needed to build an
 initramfs with dracut, with live image capabilities, like Live CDs.

Package: dracut-config-generic
Architecture: all
Depends: dracut-core, ${misc:Depends}
Multi-Arch: foreign
Description: dracut is an event driven initramfs infrastructure
 This is the dracut configuration to turn off hostonly image generation

Package: dracut-config-rescue
Architecture: all
Depends: dracut-core, ${misc:Depends}
Multi-Arch: foreign
Description: dracut is an event driven initramfs infrastructure
 This is the dracut configuration to turn on rescue image generation

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --systemdsystemunitdir=/lib/systemd/system --libdir=/usr/lib
	$(SHELL) debian/fix-revdate

override_dh_fixperms-arch:
	dh_fixperms
	find debian/ -name "*.sh" | grep modules.d | xargs chmod 755

override_dh_fixperms-indep:
	dh_fixperms
	find debian/ -name "*.sh" | grep modules.d | xargs chmod 755
	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.asc
	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.8

override_dh_auto_test:

override_dh_clean:
	dh_clean dracut.pc Makefile.inc dracut-version.sh src/skipcpio/skipcpio src/util/util
	git status|grep modified: | awk '/.asc/ {print $$2}' | xargs -r git checkout

=== debian/tests/control ===
# Note: These tests need root on Ubuntu, because the kernel is only readable by root. See https://launchpad.net/bugs/759725
# Skip following test cases that also fail upstream:
# * TEST-20-NFS: https://github.com/dracutdevs/dracut/issues/1901
# * TEST-30-ISCSI: https://github.com/dracutdevs/dracut/issues/2497
# * TEST-35-ISCSI-MULTI: https://github.com/dracutdevs/dracut/issues/2498
# * TEST-50-MULTINIC: disabled in upstream CI since 2023-01-02
# * TEST-60-BONDBRIDGEVLAN: https://github.com/dracutdevs/dracut/issues/2328
# arm64, armhf, ppc64el, and s390x need upstream support: https://github.com/dracutdevs/dracut/issues/2493
Architecture: amd64
Test-Command: debian/tests/run-upstream-tests SKIP="16 20 30 35 40 50 60"
Depends: btrfs-progs,
         busybox,
         cryptsetup,
         dbus-broker,
         dmraid,
         dracut-core,
         fdisk,
         gawk,
         kbd,
         linux-image-generic,
         lvm2,
         make,
         mdadm,
         mount,
         qemu-kvm,
         systemd-boot-efi,
         systemd-sysv,
         util-linux
Restrictions: allow-stderr, needs-root
Features: test-name=upstream-dracut-core

Architecture: amd64
Test-Command: debian/tests/run-upstream-tests TESTS="16"
Depends: btrfs-progs,
         busybox,
         dbus-broker,
         dracut-live,
         fdisk,
         kbd,
         linux-image-generic,
         make,
         mount,
         parted,
         qemu-kvm,
         squashfs-tools,
         systemd-sysv,
         util-linux
Restrictions: allow-stderr, needs-root
Features: test-name=upstream-dracut-live

Architecture: amd64
Test-Command: debian/tests/run-upstream-tests TESTS="40"
Depends: cryptsetup,
         dracut-network,
         gawk,
         iproute2,
         iputils-ping,
         isc-dhcp-server,
         linux-image-generic,
         lvm2,
         make,
         mdadm,
         mount,
         nbd-client,
         nbd-server,
         procps,
         qemu-kvm,
         systemd-sysv,
         util-linux,
         vim
Restrictions: allow-stderr, needs-root
Features: test-name=upstream-dracut-network

## dracut 060%2B5

=== debian/tests/control ===
--- 
+++ 
@@ -11,7 +11,6 @@
 Depends: btrfs-progs,
          busybox,
          cryptsetup,
-         dbus-broker,
          dmraid,
          dracut-core,
          fdisk,
@@ -33,7 +32,6 @@
 Test-Command: debian/tests/run-upstream-tests TESTS="16"
 Depends: btrfs-progs,
          busybox,
-         dbus-broker,
          dracut-live,
          fdisk,
          kbd,

## dracut 060+5

=== Makefile ===
--- 
+++ 
@@ -1,17 +1,16 @@
 -include dracut-version.sh
 
-DRACUT_MAIN_VERSION := $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --abbrev=0 --tags --always 2>/dev/null || :)
+DRACUT_MAIN_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --abbrev=0 --tags --always 2>/dev/null || :)
 ifeq ($(DRACUT_MAIN_VERSION),)
 DRACUT_MAIN_VERSION = $(DRACUT_VERSION)
 endif
-DRACUT_FULL_VERSION := $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --tags --always 2>/dev/null || :)
+DRACUT_FULL_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --tags --always 2>/dev/null || :)
 ifeq ($(DRACUT_FULL_VERSION),)
 DRACUT_FULL_VERSION = $(DRACUT_VERSION)
 endif
 
-HAVE_SHELLCHECK ?= $(shell which shellcheck >/dev/null 2>&1 && echo yes)
-HAVE_SHFMT ?= $(shell which shfmt >/dev/null  2>&1 && echo yes)
-HAVE_RPMBUILD ?= $(shell which rpmbuild >/dev/null  2>&1 && echo yes)
+HAVE_SHELLCHECK ?= $(shell command -v shellcheck >/dev/null 2>&1 && echo yes)
+HAVE_SHFMT ?= $(shell command -v shfmt >/dev/null  2>&1 && echo yes)
 
 -include Makefile.inc
 
@@ -49,9 +48,9 @@
 
 manpages = $(man1pages) $(man5pages) $(man7pages) $(man8pages)
 
-.PHONY: install clean archive rpm srpm testimage test all check AUTHORS CONTRIBUTORS doc dracut-version.sh
-
-all: dracut-version.sh dracut.pc dracut-install src/skipcpio/skipcpio dracut-util
+.PHONY: install clean archive testimage test all check AUTHORS CONTRIBUTORS doc
+
+all: dracut.pc dracut-install src/skipcpio/skipcpio dracut-util
 
 %.o : %.c
 	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(KMOD_CFLAGS) $< -o $@
@@ -219,18 +218,13 @@
 	mkdir -p $(DESTDIR)${pkgconfigdatadir}
 	install -m 0644 dracut.pc $(DESTDIR)${pkgconfigdatadir}/dracut.pc
 
-dracut-version.sh:
-	@rm -f dracut-version.sh
-	@printf "#!/bin/sh\n# shellcheck disable=SC2034\nDRACUT_VERSION=%s\n" "$(DRACUT_FULL_VERSION)" > dracut-version.sh
-
 clean:
 	$(RM) *~
 	$(RM) */*~
 	$(RM) */*/*~
 	$(RM) $(manpages:%=%.xml) dracut.xml
 	$(RM) test-*.img
-	$(RM) dracut-*.rpm dracut-*.tar.bz2 dracut-*.tar.xz
-	$(RM) dracut-version.sh
+	$(RM) dracut-*.tar.bz2 dracut-*.tar.xz
 	$(RM) dracut-install src/install/dracut-install $(DRACUT_INSTALL_OBJECTS)
 	$(RM) skipcpio/skipcpio $(SKIPCPIO_OBJECTS)
 	$(RM) dracut-util util/util $(UTIL_OBJECTS)
@@ -242,44 +236,64 @@
 dist: dracut-$(DRACUT_MAIN_VERSION).tar.xz
 
 dracut-$(DRACUT_MAIN_VERSION).tar.xz: doc syncheck
-	@echo "DRACUT_VERSION=$(DRACUT_MAIN_VERSION)" > dracut-version.sh
 	git archive --format=tar $(DRACUT_MAIN_VERSION) --prefix=dracut-$(DRACUT_MAIN_VERSION)/ > dracut-$(DRACUT_MAIN_VERSION).tar
 	mkdir -p dracut-$(DRACUT_MAIN_VERSION)
-	for i in $(manpages) dracut.html dracut-version.sh; do [ "$${i%/*}" != "$$i" ] && mkdir -p "dracut-$(DRACUT_MAIN_VERSION)/$${i%/*}"; cp "$$i" "dracut-$(DRACUT_MAIN_VERSION)/$$i"; done
+	for i in $(manpages) dracut.html; do [ "$${i%/*}" != "$$i" ] && mkdir -p "dracut-$(DRACUT_MAIN_VERSION)/$${i%/*}"; cp "$$i" "dracut-$(DRACUT_MAIN_VERSION)/$$i"; done
 	tar --owner=root --group=root -rf dracut-$(DRACUT_MAIN_VERSION).tar $$(find dracut-$(DRACUT_MAIN_VERSION) -type f)
 	rm -fr -- dracut-$(DRACUT_MAIN_VERSION).tar.xz dracut-$(DRACUT_MAIN_VERSION)
 	xz -9 dracut-$(DRACUT_MAIN_VERSION).tar
 	rm -f -- dracut-$(DRACUT_MAIN_VERSION).tar
 
-ifeq ($(HAVE_RPMBUILD),yes)
-rpm: dracut-$(DRACUT_MAIN_VERSION).tar.xz syncheck
-	rpmbuild=$$(mktemp -d -p /var/tmp rpmbuild-dracut.XXXXXX); src=$$(pwd); \
-	cp dracut-$(DRACUT_MAIN_VERSION).tar.xz "$$rpmbuild"; \
-	LC_MESSAGES=C $$src/tools/git2spec.pl $(DRACUT_MAIN_VERSION) "$$rpmbuild" < pkgbuild/dracut.spec > $$rpmbuild/dracut.spec; \
-	(cd "$$rpmbuild"; \
-	wget https://www.gnu.org/licenses/lgpl-2.1.txt; \
-	rpmbuild --define "_topdir $$PWD" --define "_sourcedir $$PWD" \
-	        --define "_specdir $$PWD" --define "_srcrpmdir $$PWD" \
-		--define "_rpmdir $$PWD" -ba dracut.spec; ) && \
-	( mv "$$rpmbuild"/{,$$(uname -m)/}*.rpm $(DESTDIR).; rm -fr -- "$$rpmbuild"; ls $(DESTDIR)*.rpm )
-
-srpm: dracut-$(DRACUT_MAIN_VERSION).tar.xz syncheck
-	rpmbuild=$$(mktemp -d -t rpmbuild-dracut.XXXXXX); src=$$(pwd); \
-	cp dracut-$(DRACUT_MAIN_VERSION).tar.xz "$$rpmbuild"; \
-	LC_MESSAGES=C $$src/tools/git2spec.pl $(DRACUT_MAIN_VERSION) "$$rpmbuild" < pkgbuild/dracut.spec > $$rpmbuild/dracut.spec; \
-	(cd "$$rpmbuild"; \
-	[ -f $$src/lgpl-2.1.txt ] && cp $$src/lgpl-2.1.txt . || wget https://www.gnu.org/licenses/lgpl-2.1.txt; \
-	rpmbuild --define "_topdir $$PWD" --define "_sourcedir $$PWD" \
-	        --define "_specdir $$PWD" --define "_srcrpmdir $$PWD" \
-		--define "_rpmdir $$PWD" -bs dracut.spec; ) && \
-	( mv "$$rpmbuild"/*.src.rpm $(DESTDIR).; rm -fr -- "$$rpmbuild"; ls $(DESTDIR)*.rpm )
-else
-.PHONY: rpm srpm
-rpm: syncheck
-srpm: syncheck
-endif
-
 syncheck:
 	@ret=0;for i in dracut-initramfs-restore.sh modules.d/*/*.sh; do \
                 [ "$${i##*/}" = "module-setup.sh" ] && continue; \
                 read line < "$$i"; [ "$${line#*bash*}" != "$$line" ] && continue; \
+		[ $$V ] && echo "posix syntax check: $$i"; bash --posix -n "$$i" ; ret=$$(($$ret+$$?)); \
+		[ $$V ] && echo "checking for [[: $$i"; if grep -Fq '[[ ' "$$i" ; then ret=$$(($$ret+1)); echo "$$i contains [["; fi; \
+		[ $$V ] && echo "checking for echo -n: $$i"; if grep -Fq 'echo -n ' "$$i" ; then ret=$$(($$ret+1)); echo "$$i contains echo -n"; fi \
+	done;exit $$ret
+	@ret=0;for i in *.sh modules.d/*/*.sh modules.d/*/module-setup.sh; do \
+		[ $$V ] && echo "bash syntax check: $$i"; bash -n "$$i" ; ret=$$(($$ret+$$?)); \
+	done;exit $$ret
+ifeq ($(HAVE_SHELLCHECK),yes)
+ifeq ($(HAVE_SHFMT),yes)
+	shellcheck $$(shfmt -f .)
+else
+	find . -name '*.sh' -print0 | xargs -0 shellcheck
+endif
+endif
+
+check: all syncheck
+	@[ "$$EUID" == "0" ] || { echo "'check' must be run as root! Please use 'sudo'."; exit 1; }
+	@$(MAKE) -C test check
+
+testimage: all
+	./dracut.sh -N -l -a debug -f test-$(KVERSION).img $(KVERSION)
+	@echo wrote  test-$(KVERSION).img
+
+debugtestimage: all
+	./dracut.sh --debug -l -a debug -f test-$(KVERSION).img $(KVERSION)
+	@echo wrote  test-$(KVERSION).img
+
+testimages: all
+	./dracut.sh -l -a debug --kernel-only -f test-kernel-$(KVERSION).img $(KVERSION)
+	@echo wrote  test-$(KVERSION).img
+	./dracut.sh -l -a debug --no-kernel -f test-dracut.img $(KVERSION)
+	@echo wrote  test-dracut.img
+
+debughostimage: all
+	./dracut.sh --debug -H -l -f test-$(KVERSION).img $(KVERSION)
+	@echo wrote  test-$(KVERSION).img
+
+hostimage: all
+	./dracut.sh -H -l -f test-$(KVERSION).img $(KVERSION)
+	@echo wrote  test-$(KVERSION).img
+
+efi: all
+	./dracut.sh --uefi -H -l -f linux-$(KVERSION).efi $(KVERSION)
+	@echo wrote linux-$(KVERSION).efi
+
+AUTHORS:
+	@git log | git shortlog --numbered --summary -e | while read -r a rest || [ -n "$$rest" ]; do echo "$$rest"; done > AUTHORS
+
+CONTRIBUTORS:

=== src/util/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)
project(dracut-util C)

set(CMAKE_C_STANDARD 99)

add_executable(dracut-util util.c)

=== debian/changelog ===
dracut (060+5-1ubuntu3) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 17:56:43 +0200

dracut (060+5-1ubuntu2) noble; urgency=medium

  * d/p/ldconfig-real.patch: make sure ldconfig.real is installed where needed
    (LP: #2053057)

 -- Nick Rosbrook <enr0n@ubuntu.com>  Tue, 13 Feb 2024 11:26:56 -0500

dracut (060+5-1ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - fix(test): running tests no longer requires to be root
    - Add modules 80test, 80test-makeroot, and 80test-root to dracut-core
    - Add autopkgtest to run upstream test cases on amd64 (LP: #2031417)
    - Split dracut-install into separate package for initramfs-tools
      (LP: #2031185)
  * test(FULL SYSTEMD): no need to include dbus to the target rootfs
  * Drop dbus-broker from autopkgtest

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 07 Feb 2024 18:44:09 +0100

dracut (060+5-1) unstable; urgency=medium

  * upstream changed the release process, and do not tag the releases any
    more
  * 059+212 was already version 060+5
  * add dracut-network.conffiles, Closes: 1057807

 -- Thomas Lange <lange@debian.org>  Fri, 08 Dec 2023 21:09:47 +0100

dracut (059+212-3) unstable; urgency=medium

  * fix handling of dracut-version.sh

 -- Thomas Lange <lange@debian.org>  Wed, 06 Dec 2023 14:36:26 +0100

dracut (059+212-2) unstable; urgency=low

  * debian/rules: use correct Debian version

 -- Thomas Lange <lange@debian.org>  Wed, 06 Dec 2023 12:00:30 +0100

dracut (059+212-1) unstable; urgency=low

  * merge upstream changes, Closes: #1056059, #1041562, #1054400, #1016052

 -- Thomas Lange <lange@debian.org>  Thu, 30 Nov 2023 22:10:02 +0100

=== debian/control ===
--- 
+++ 
@@ -42,8 +42,8 @@
 Package: dracut-install
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Breaks: dracut-core (<< 059-4ubuntu2~)
-Replaces: dracut-core (<< 059-4ubuntu2~)
+Breaks: dracut-core (<< 059-5~)
+Replaces: dracut-core (<< 059-5~)
 Description: dracut is an event driven initramfs infrastructure (dracut-install)
  This package just contains the dracut-install command to be used by
  initramfs generating tools.
@@ -51,7 +51,7 @@
 Package: dracut-network
 Architecture: all
 Recommends: nfs-common, open-iscsi, nbd-client, curl
-Depends: dracut-core, iputils-arping, isc-dhcp-client, ${misc:Depends}
+Depends: dracut-core, iputils-arping, isc-dhcp-client | systemd | connman | network-manager, ${misc:Depends}
 Description: dracut is an event driven initramfs infrastructure (network modules)
  Package to build a dracut initramfs with network support. This
  includes dracut modules for NFS, CIFS, iSCSI, HTTP, NBD, FCP and FCOE.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/dracutdevs/dracut/tags \
    (?:.*?/)?([\d]{3})\.tar\.gz debian

## dracut 102

=== test/Makefile ===
--- 
+++ 
@@ -1,7 +1,6 @@
 .PHONY: all check clean $(wildcard TEST-??-*)
 
 $(wildcard TEST-??-*):
-	@[ "$(shell id -u)" = 0 ] || { echo "'check' must be run as root! Please use 'sudo'."; exit 1; }
 	@{ \
 		[ -d $@ ] || exit 0; \
 		[ -f $@/Makefile ] || exit 0; \

=== debian/changelog ===
dracut (102-3ubuntu4) oracular; urgency=medium

  * Cherry-pick upstream fixes for systemd 256 (LP: #2069290):
    - fix(test): use --add instead of --modules to create test-makeroot
    - test: avoid writing to rootfs as it might be read-only
  * fix(dracut-initramfs-restore.sh): correct initrd globbing
  * feat(lsinitrd.sh): support configurable initrd filenames
  * Default initrdname to initrd.img-${kernel}
  * Cherry-pick upstream performance fixes (LP: #2065180):
    - perf(dracut-install): memoize find_kmod_module_from_sysfs_node
    - perf(dracut-install): use driver/module sysfs dirs for module name
  * test: virtual hardware watchdog not available on s390x

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 08 Jul 2024 20:37:51 +0200

dracut (102-3ubuntu3) oracular; urgency=medium

  * autopkgtest: set ARCH to dpkg architecture
  * dracut-core:
    - drop recommending pkgconf
    - drop depending directly on libkmod2. dracut-install links against it.
    - demote cryptsetup, dmraid, dmsetup, kpartx, lvm2, mdadm to suggests
    - demote binutils to suggests. its only needed when using UEFI executables.
    - recommend zstd instead of pigz and default to zstd
  * Drop dracut-config-generic. Building a generic image is and will be the
    default.

 -- Benjamin Drung <bdrung@ubuntu.com>  Thu, 27 Jun 2024 23:07:12 +0200

dracut (102-3ubuntu2) oracular; urgency=medium

  * dracut: use await variant of update-initramfs trigger
  * fix(shell-completion): remove hashbang from bash completions
  * drop udevsettle patch (these kind of patches should be applied upstream)
  * drop nm-path patch (network-manager ships the helpers in /usr/libexec)
  * drop 90overlay-root in favor of 90overlayfs (Closes: #1017039)
  * run autopkgtest with V=2
  * autopkgtest: depend on tpm2-tools for systemd-pcrphase (LP: #2069290)
  * run autopkgtest on all architectures
  * autopkgtest: disable using KVM for ppc64el

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 14 Jun 2024 01:57:17 +0200

dracut (102-3ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - autopkgtest: Enable dmraid upstream test 14
    - Run upstream autopkgtest as root
    - disable using DH_VERBOSE=1
    - perf(dracut-install): preload kmod resources for quicker module lookup
      (LP: #2065180)
  * dracut-core: add new modules 01systemd-bsod, 01systemd-creds, 90numlock,
    90pcmcia
  * Explicitly mark 45ifcfg module as not installed
  * Switch to debhelper 13
  * test(RAID-DEG): fix running test out of tree

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 12 Jun 2024 19:38:43 +0200

dracut (102-3) unstable; urgency=medium

  * add module net-lib, Closes: #1072744
  * remove obsolete patch fido-libz

 -- Thomas Lange <lange@debian.org>  Fri, 07 Jun 2024 13:57:47 +0200

dracut (102-2) unstable; urgency=medium

  * add 90systemd-cryptsetup module, Closes: 1072538

 -- Thomas Lange <lange@debian.org>  Tue, 04 Jun 2024 11:38:08 +0200

dracut (102-1) unstable; urgency=low

  * new upstream:
    Closes: 1029324, 1041614, 1022129, 1071592, 1072174, 1068250
    Closes: 1071182, 1059501
  * change to new dracut-ng upstream repository, the package name remains
    unchanged
  * apply salsa MR #11, Closes: 753752
  * move kpartx from depends to recommends, Closes: 1033158

 -- Thomas Lange <lange@debian.org>  Mon, 03 Jun 2024 14:14:11 +0200

dracut (060+5-8ubuntu2) oracular; urgency=medium

  * perf(dracut-install): preload kmod resources for quicker module lookup
    (LP: #2065180)

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 04 Jun 2024 16:33:13 +0200

dracut (060+5-8ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - autopkgtest: Enable dmraid upstream test 14
    - Run upstream autopkgtest as root
    - disable using DH_VERBOSE=1
    - d/p/ldconfig-real.patch: make sure ldconfig.real is installed where
      needed (LP: #2053057)

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 21 May 2024 17:38:39 +0200

dracut (060+5-8) unstable; urgency=low

  * control: adjust breaks, replaces, Closes: #1071208, #1071244
  * add patch taken from dracut-ng, Closes: #1071182

 -- Thomas Lange <lange@debian.org>  Sun, 19 May 2024 16:45:33 +0200

dracut (060+5-7) unstable; urgency=low

  * control: update package depends name
  * add lintian override

 -- Thomas Lange <lange@debian.org>  Mon, 01 Apr 2024 23:01:58 +0200

dracut (060+5-2) unstable; urgency=low

  * set --systemdsystemunitdir from pkg-config, MR #32, Closes: #1057927
  * split dracut-install into separate package for initramfs-tools, MR #27
  * enable autopkgtest test suite, MR #24

 -- Thomas Lange <lange@debian.org>  Sun, 31 Mar 2024 19:05:19 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Thomas Lange <lange@debian.org>
-Build-Depends: debhelper-compat (= 12), debhelper, asciidoc-base, xsltproc, docbook-xsl, docbook-xml, quilt, libkmod-dev, pkg-config
+Build-Depends: debhelper-compat (= 13), debhelper, asciidoc-base, xsltproc, docbook-xsl, docbook-xml, quilt, libkmod-dev, pkgconf, systemd-dev
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/dracut
 Vcs-Git: https://salsa.debian.org/debian/dracut.git
-Homepage: https://github.com/dracutdevs/dracut/wiki/
+Homepage: https://github.com/dracut-ng/dracut-ng/wiki
 
 Package: dracut
 Architecture: all
@@ -24,8 +24,9 @@
 Package: dracut-core
 Architecture: any
 Multi-Arch: foreign
-Recommends: cryptsetup, dmsetup, dmraid, lvm2, mdadm, console-setup, binutils, systemd, pigz, pkg-config
-Depends: cpio, dracut-install, kmod, udev, kpartx, libkmod2, e2fsprogs, ${shlibs:Depends}, ${misc:Depends}
+Recommends: console-setup, systemd, zstd
+Depends: cpio, dracut-install, kmod, udev, e2fsprogs, ${shlibs:Depends}, ${misc:Depends}
+Suggests: binutils, cryptsetup, dmraid, dmsetup, kpartx, lvm2, mdadm
 Breaks: dracut-network (<< 057+157-2), dracut-live (<< 059-2)
 Replaces: dracut-network (<< 057+157-2), dracut-live (<< 059-2)
 Description: dracut is an event driven initramfs infrastructure (core tools)
@@ -42,8 +43,8 @@
 Package: dracut-install
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Breaks: dracut-core (<< 059-5~)
-Replaces: dracut-core (<< 059-5~)
+Breaks: dracut-core (<< 060+5-7~)
+Replaces: dracut-core (<< 060+5-7~)
 Description: dracut is an event driven initramfs infrastructure (dracut-install)
  This package just contains the dracut-install command to be used by
  initramfs generating tools.
@@ -80,13 +81,6 @@
  This package requires everything which is needed to build an
  initramfs with dracut, with live image capabilities, like Live CDs.
 
-Package: dracut-config-generic
-Architecture: all
-Depends: dracut-core, ${misc:Depends}
-Multi-Arch: foreign
-Description: dracut is an event driven initramfs infrastructure
- This is the dracut configuration to turn off hostonly image generation
-
 Package: dracut-config-rescue
 Architecture: all
 Depends: dracut-core, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DRACUT_MAIN_VERSION=$(DEB_VERSION_UPSTREAM_REVISION)
export DRACUT_FULL_VERSION=$(DEB_VERSION)

deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --systemdsystemunitdir=/$(deb_systemdsystemunitdir) --libdir=/usr/lib
	$(SHELL) debian/fix-revdate
	mv dracut-version.sh dracut-version.sh.orig
	echo '#!/bin/sh' > dracut-version.sh
	echo "DRACUT_VERSION=$${DRACUT_FULL_VERSION}" >> dracut-version.sh

override_dh_fixperms-arch:
	dh_fixperms
	find debian/ -name "*.sh" | grep modules.d | xargs chmod 755

override_dh_fixperms-indep:
	dh_fixperms
	find debian/ -name "*.sh" | grep modules.d | xargs chmod 755
	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.asc
	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.8
ifneq ($(DEB_HOST_ARCH), s390x)
	for m in 80cms 81cio_ignore 91zipl 95dasd 95dasd_mod \
		95dcssblk 95zfcp \
		95znet; do \
		rm -rf debian/*/usr/lib/dracut/modules.d/$$m ; \
	done
else
	rm -rf debian/*/usr/lib/dracut/modules.d/00warpclock
endif

override_dh_auto_test:

override_dh_install:
	dh_install
	dh_install -pdracut-core $(deb_systemdsystemunitdir)

override_dh_clean:
	if test -e dracut-version.sh.orig ; then \
	   mv -f dracut-version.sh.orig dracut-version.sh ;\
	fi
	dh_clean dracut.pc Makefile.inc src/skipcpio/skipcpio src/util/util
	git status|grep modified: | awk '/.asc/ {print $$2}' | xargs -r git checkout

=== debian/tests/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 # Note: These tests need root on Ubuntu, because the kernel is only readable by root. See https://launchpad.net/bugs/759725
-# Skip following test cases that also fail upstream:
+# Skip following test cases:
 # * TEST-20-NFS: https://github.com/dracutdevs/dracut/issues/1901
 # * TEST-30-ISCSI: https://github.com/dracutdevs/dracut/issues/2497
 # * TEST-35-ISCSI-MULTI: https://github.com/dracutdevs/dracut/issues/2498
 # * TEST-50-MULTINIC: disabled in upstream CI since 2023-01-02
 # * TEST-60-BONDBRIDGEVLAN: https://github.com/dracutdevs/dracut/issues/2328
 # arm64, armhf, ppc64el, and s390x need upstream support: https://github.com/dracutdevs/dracut/issues/2493
-Architecture: amd64
+Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
 Test-Command: debian/tests/run-upstream-tests SKIP="16 20 30 35 40 50 60"
 Depends: btrfs-progs,
          busybox,
@@ -21,14 +21,18 @@
          make,
          mdadm,
          mount,
+         qemu-efi-aarch64 [arm64],
+         qemu-efi-arm [armhf],
          qemu-kvm,
+         seabios [ppc64el],
          systemd-boot-efi,
          systemd-sysv,
+         tpm2-tools,
          util-linux
 Restrictions: allow-stderr, needs-root
 Features: test-name=upstream-dracut-core
 
-Architecture: amd64
+Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
 Test-Command: debian/tests/run-upstream-tests TESTS="16"
 Depends: btrfs-progs,
          busybox,
@@ -39,20 +43,24 @@
          make,
          mount,
          parted,
+         qemu-efi-aarch64 [arm64],
+         qemu-efi-arm [armhf],
          qemu-kvm,
+         seabios [ppc64el],
          squashfs-tools,
          systemd-sysv,
          util-linux
 Restrictions: allow-stderr, needs-root
 Features: test-name=upstream-dracut-live
 
-Architecture: amd64
+Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
 Test-Command: debian/tests/run-upstream-tests TESTS="40"
 Depends: cryptsetup,
          dracut-network,
          gawk,
          iproute2,
          iputils-ping,
+         isc-dhcp-client,
          isc-dhcp-server,
          linux-image-generic,
          lvm2,
@@ -62,7 +70,10 @@
          nbd-client,
          nbd-server,
          procps,
+         qemu-efi-aarch64 [arm64],
+         qemu-efi-arm [armhf],
          qemu-kvm,
+         seabios [ppc64el],
          systemd-sysv,
          util-linux,
          vim
